
"""
Napisati baznu klasu NulaFunkcije, koja opisuje funkcije cije nule se mogu naci priblizno koriscenjem numerickih metoda. Klasa sadrzi sledece atribute:
* ime - niska (dozvoljene vrednosti su 'sin', 'cos', 'log')
* a - realan broj
* eps - konstanta cija je vrednost 1.0e-4

Implementirati sledece metode:

*  Konstruktor - postavlja vrednosti atributa na prosledjene vrednosti. Ukoliko ime nije iz dozvoljenog skupa postaviti vrednost na 'sin'.
*  _ _ str() _ _ - vraca nisku oblika 'Nula funkcije *ime*(x)'
*  vrednostFunkcije(x) - vraca vrednost funkcije u datoj tacki x
"""

import math

class NulaFunkcije:
  def __init__(self, ime, a, eps = 1.0e-4):
    if not ime in ['sin', 'cos', 'log']:
      ime = 'sin'
    self.ime = ime
    self.a = a
    self.eps = eps

  def __str__(self):
    return "Nula funkcije "+self.ime+"(x)"

  def vrednostFje(moje, x):
    if moje.ime == 'sin':
      return math.sin(x)

    if moje.ime == 'cos':
      return math.cos(x)

    if moje.ime == 'log':
      return math.log2(x)

nf = NulaFunkcije('arccos', 4)
print(nf)

"""
Napisati klasu **PolovljenjeOdsecaka** koja nasledjuje klasu NulaFunkcije i sluzi za priblizno racunanje nule funkcije metodom polovljenja odsecaka. Nula funkcije trazi se na odsecku [a,b], gde je b realan broj.
Klasa sadrzi sledece atribute:
* b - realan broj

Implementirati sledece metode:
*  Konstruktor - konstruktoru se prosledjuju argumenti ime, a i b. Na odgovarajuci nacin izvrsiti dodeljivanje vrednosti atributima.
*  _ _ str() _ _ - vraca nisku sledeceg oblika: 'Nula funkcije *ime*(x) na intervalu [*a,b*] je *nula()*'
*  nula() - racuna i vraca nulu funkcije koristeci metodu polovljenja intervala.

**NAPOMENA**

*Metoda polovljenja odsečaka*
KORISTAN LINK: https://sr.wikipedia.org/wiki/%D0%9C%D0%B5%D1%82%D0%BE%D0%B4%D0%B0_%D0%BF%D0%BE%D0%BB%D0%BE%D0%B2%D1%99%D0%B5%D1%9A%D0%B0_%D0%B8%D0%BD%D1%82%D0%B5%D1%80%D0%B2%D0%B0%D0%BB%D0%B0
"""

class PolovljenjeOdsecaka(NulaFunkcije):
  def __init__(self, ime, a, b, eps = 1.0e-4):
    super().__init__(ime, a, eps)
    self.b = b
  def __str__(self):
    return super().__str__()+" na intervalu ["+str(self.a)+", "+str(self.b)+"] je "+str(self.nula())

  def nula(self):
    levo = self.a
    desno = self.b
    while abs(desno - levo) > self.eps:
      sredina = (desno + levo)/2
      if self.vrednostFje(levo)*self.vrednostFje(sredina) > 0:
        levo = sredina
      elif self.vrednostFje(levo)*self.vrednostFje(sredina) == 0:
        return sredina
      else:
        desno = sredina

    return (desno + levo)/2

po = PolovljenjeOdsecaka('sin', -0.7, 0.8)
print(po)

"""Napisati klasu Njutn koja nasledjuje klasu NulaFunkcije i sluzi za priblizno racucanje nule funkcije Njutnovom metodom. Metoda je iterativna pa je potrebno broj iteracija ograniciti na MAXITER=10.

Klasa sadrzi sledece atribute:

* MAXITER - konstanta vrednost je 10

Implementirati sledece metode:
*  Konstruktor - prosledjuju se argumenti ime, a. Na odgovarajuci nacin izvrsiti dodeljivanje vrednosti atributa.
*  _ _ str() _ _ - vraca nisku sledeceg oblika: 'Nula funkcije *ime*(x) u okolini tacke *a* je *nula*()'
*  fPrim(x) - racuna i vraca vrednost prvoh izvoda funkcije u datoj tacki x.
*  nula() - racuna i vraca nulu funkcije koristeci Njutnovu metodu.

**NAPOMENA**

*Njutnova metoda*

Njutnova metoda je zadata formulama:

x0=a
x(n+1) = xn - f(xn)/f'(xn), n=0,1,2\dots$$

Sa izracunavanjem se staje kada se postigne zeljena tacnost, tj. $| x(n+1) - xn| ≼ ε$ ili se premasi maksimalni broj dozvoljenih iteracija.

ZADATAK ZA VEZBANJE

"""




